<script>
	import PKCE from "js-pkce"
	import { getContext } from "svelte"
	import { browser } from "$app/env"
	import { AUTH_CONTEXT_KEY } from "$lib/constants"
	import * as storage from "$lib/infrastructure/storage"

	let loginCallbackError

	async function handleLoginCallback() {
		const { pkceConfig } = getContext(AUTH_CONTEXT_KEY)
		const pkce = new PKCE(pkceConfig)

		let response
		try {
			response = await pkce.exchangeForAccessToken(window.location.href)
		} catch (error) {
			// TODO use logging library
			console.error(error)
			loginCallbackError = error.error
			return
		}
		if (response.error) {
			// TODO use logging library
			console.error(response)
			loginCallbackError = `${response.error}: ${response.error_description}`
			return
		}

		storage.setTokens(response)
		// Do not use SvelteKit goto function to force a full page reload.
		window.location.replace(storage.getReturnTo() || "/") // TODO handle base URL
	}

	if (browser) {
		handleLoginCallback()
	}
</script>

<slot />

{#if loginCallbackError}
	<slot name="error">
		<p>Error: {loginCallbackError}</p>
	</slot>
{/if}
